package main

import (
	"fmt"
	"strconv"
	"strings"
)

func main() {}

type Result int

const (
	Correct Result = iota
	Incorrect
	Invalid_format
)

//export Barcode_checksum
func Barcode_checksum(barcode int64) Result {
	_barcode := strconv.FormatInt(barcode, 10)
	// values := []byte(_barcode) // Get ASCII values...
	elements := strings.Split(_barcode, "")
	if len(elements) == 13 {
		_data := [13]int{}
		for index, character := range elements {
			element, error := strconv.Atoi(character)
			if error != nil {
				return Invalid_format
			}
			_data[index] = element
		}
		if _Checksum(_data) == _data[len(_data)-1] {
			fmt.Println("Barcode: " + _barcode + " is correct...") // WASI support generated by '-target=wasi' at build time...
			return Correct
		}
		return Incorrect
	}
	return Invalid_format
}

func _Checksum(_data [13]int) int {
	remainder := 0
	for index, datum := range _data {
		if index%2 != 0 {
			remainder += 3 * datum
		}
	}
	for index, datum := range _data {
		if index%2 == 0 && index != len(_data)-1 {
			remainder += datum
		}
	}
	if remainder%10 == 0 {
		return 0
	}
	return 10 - remainder%10
}
